#include <stdlib.h>
#include <stdio.h>
#include <math.h>

void read_file (FILE *fp, int *npart, int *ndim, double **pos) {
  int i, n, err;
  double x, y, z;
  char a[256];
  err = fscanf(fp,"%d\n",&n);
  err = fscanf(fp,"%[^\n]\n",a);
  *ndim = 3;
  *npart = n;
  *pos = malloc((*ndim)*n*sizeof(double));
  for (i=0; i<n; i++) {
    err = fscanf(fp, "%s %lf %lf %lf\n", a, &x, &y, &z);
    (*pos)[i*(*ndim)]   = x;
    (*pos)[i*(*ndim)+1] = y;
    (*pos)[i*(*ndim)+2] = z;
  }
}

void write_file (FILE *fp, int ndim, int n, double pos[]) {
  int i, j;
  for (j=0; j<n; j++) {
    fprintf(fp, "A %f %f %f\n",  pos[j*ndim],  pos[j*ndim+1],  pos[j*ndim+2]);
  }
}

int main (int argc, char * argv[]) {
  int i, n, ndim;
  double *pos;
  FILE *finp, *fout;

  finp = fopen("input.xyz","r");
  fout  = fopen("output.xyz","w");
  read_file(finp, &n, &ndim, &pos);
  write_file(fout, ndim, n, pos);
  close(fout);
  close(finp);
  return 0;
}
