MODULE kernels

  IMPLICIT NONE

  INTEGER, PARAMETER :: NDIM = 3

CONTAINS

  SUBROUTINE read(unit,pos)
    INTEGER, INTENT(in) :: unit
    REAL, ALLOCATABLE   :: pos(:,:)
    CHARACTER(6)        :: string
    INTEGER             :: i, n
    READ(unit,*) n
    READ(unit,*) 
    IF (ALLOCATED(pos)) DEALLOCATE(pos)
    ALLOCATE(pos(NDIM,n))
    DO i = 1,n
       READ(unit,*) string,pos(:,i)
    END DO
  END SUBROUTINE read

  SUBROUTINE write(unit,pos)
    INTEGER, INTENT(in) :: unit
    REAL, INTENT(in)    :: pos(:,:)
    INTEGER             :: i
    DO i = 1,SIZE(pos,2)
       WRITE(unit,*) 'A', pos(:,i)
    END DO
  END SUBROUTINE write
  
END MODULE kernels

PROGRAM main

  USE kernels

  IMPLICIT NONE

  REAL, ALLOCATABLE :: pos(:,:)
  INTEGER           :: unit_inp=100, unit_out=101
  CHARACTER(256)    :: file_inp="input.xyz", file_out="output.xyz"

  OPEN(unit=unit_inp,file=file_inp,status="old")
  OPEN(unit=unit_out,file=file_out,status="unknown")

  CALL read(unit_inp,pos)
  CALL write(unit_out,pos)

  CLOSE(unit_inp)
  CLOSE(unit_out)

END PROGRAM main
